using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using System.IO;
using System.Xml;

//important for ADO .NET and Sql Server DB
using System.Data;
using System.Data.SqlClient;

namespace Ado_Net_Demo1
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnConnect;
		private System.Windows.Forms.Button btnSave;
		private System.Windows.Forms.DataGrid dgdOrders;
		private System.Windows.Forms.SaveFileDialog dlgSaveFile;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		
		private System.Windows.Forms.Button btnLoad;
		private System.Windows.Forms.OpenFileDialog dlgOpenFile;

		//consts
		public const String dbString = "integrated security=sspi;initial catalog=Northwind;data source=localhost";
		
		
		
		//members
		private DataSet _dataset;

		//property that gets/sets and binds the dataset
		public DataSet MyDataset
		{
			get
			{
				return _dataset;
			}

			set
			{
				_dataset=value;
				dgdOrders.DataSource = _dataset;
				dgdOrders.DataMember = _dataset.Tables[0].TableName;
			}
		}

		//Returns a path to the schema file
		public String SchemaFileName
		{
			get
			{
				FileInfo fi = new FileInfo(Application.ExecutablePath);
				return fi.DirectoryName + "\\dsSchema.xml";
			}
		}



		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnConnect = new System.Windows.Forms.Button();
			this.btnSave = new System.Windows.Forms.Button();
			this.dgdOrders = new System.Windows.Forms.DataGrid();
			this.dlgSaveFile = new System.Windows.Forms.SaveFileDialog();
			this.btnLoad = new System.Windows.Forms.Button();
			this.dlgOpenFile = new System.Windows.Forms.OpenFileDialog();
			((System.ComponentModel.ISupportInitialize)(this.dgdOrders)).BeginInit();
			this.SuspendLayout();
			// 
			// btnConnect
			// 
			this.btnConnect.Location = new System.Drawing.Point(464, 216);
			this.btnConnect.Name = "btnConnect";
			this.btnConnect.TabIndex = 0;
			this.btnConnect.Text = "Connect";
			this.btnConnect.Click += new System.EventHandler(this.btnConnect_Click);
			// 
			// btnSave
			// 
			this.btnSave.Location = new System.Drawing.Point(336, 216);
			this.btnSave.Name = "btnSave";
			this.btnSave.TabIndex = 1;
			this.btnSave.Text = "Save";
			this.btnSave.Click += new System.EventHandler(this.btnSave_Click);
			// 
			// dgdOrders
			// 
			this.dgdOrders.DataMember = "";
			this.dgdOrders.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dgdOrders.Location = new System.Drawing.Point(16, 16);
			this.dgdOrders.Name = "dgdOrders";
			this.dgdOrders.Size = new System.Drawing.Size(688, 184);
			this.dgdOrders.TabIndex = 2;
			// 
			// btnLoad
			// 
			this.btnLoad.Location = new System.Drawing.Point(208, 216);
			this.btnLoad.Name = "btnLoad";
			this.btnLoad.TabIndex = 3;
			this.btnLoad.Text = "Load";
			this.btnLoad.Click += new System.EventHandler(this.btnLoad_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(728, 269);
			this.Controls.Add(this.btnLoad);
			this.Controls.Add(this.dgdOrders);
			this.Controls.Add(this.btnSave);
			this.Controls.Add(this.btnConnect);
			this.Name = "Form1";
			this.Text = "ADO .NET DEMO 1";
			((System.ComponentModel.ISupportInitialize)(this.dgdOrders)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void btnConnect_Click(object sender, System.EventArgs e)
		{
			SqlConnection con = new SqlConnection(dbString);
			con.Open();
			DataSet newDataset = new DataSet("orders");
			DataTable ordersTable = new DataTable("Order");
			newDataset.Tables.Add(ordersTable);
			SqlCommand command= new SqlCommand("Select top 3 OrderId, CustomerId, OrderDate, RequiredDate, ShippedDate, ShipAddress, ShipCity, ShipCountry from orders",con);
			SqlDataAdapter adapter = new SqlDataAdapter(command);
			adapter.Fill(ordersTable);

			con.Close();
			DataTable detailsTable = new DataTable("Details");
			newDataset.Tables.Add(detailsTable);

			String sql = null;
			foreach(DataRow r in ordersTable.Rows)
			{
				if (sql!=null)
					sql+=" or ";
				sql+="OrderId =" + r["orderId"];

			}

			if(sql!=null)
			{
				sql = "SELECT OrderID, ProductID, UnitPrice, Quantity, Discount from [Order Details] where " +sql;
				//adapter will open connection and create a command transparently
				SqlDataAdapter sqlda = new SqlDataAdapter(sql,dbString);
				sqlda.Fill(detailsTable);

				newDataset.Relations.Add("Details", ordersTable.Columns["OrderId"], detailsTable.Columns["OrderId"]);

			}
			newDataset.WriteXmlSchema(this.SchemaFileName);
			MyDataset = newDataset;
		}

		private void btnSave_Click(object sender, System.EventArgs e)
		{
			if(_dataset!=null)
			{
				dlgSaveFile.Filter="XML Files (*.xml)|*.xml|All Files (*.*)|*.*||";
				if(dlgSaveFile.ShowDialog() == DialogResult.OK)
				{
					_dataset.WriteXml(dlgSaveFile.FileName);
				}

			}
			else
			{
				MessageBox.Show("Not Connected!");
			}

		}

		private void btnLoad_Click(object sender, System.EventArgs e)
		{
			dlgOpenFile.Filter="XML Files (*.xml)|*.xml|All Files (*.*)|*.*||";
			if(dlgOpenFile.ShowDialog()==DialogResult.OK)
			{
				try
				{
					DataSet newDataset = new DataSet();
					newDataset.ReadXmlSchema(this.SchemaFileName);//load the schema
					newDataset.ReadXml(dlgOpenFile.FileName);
					MyDataset = newDataset;
				}
				catch(Exception ee){
					MessageBox.Show("Bad File:" + ee.Message);
				}

			}
		}

	}
}
