using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using Ado_Web_Client.Ado_Web_Service;

namespace Ado_Web_Client
{

	/*
	 * supplies a form for adding students arrival times and viewing the 
	 * arrival times.
	 */ 
	public class WebForm1 : System.Web.UI.Page
	{
		protected DataSet dataSet;
		protected LectureService lectureService;

		protected System.Web.UI.WebControls.Label StudentNameLabel;
		protected System.Web.UI.WebControls.Label ChooseLectureLabel;
		protected System.Web.UI.WebControls.TextBox StudentNameTextBox;
		protected System.Web.UI.WebControls.DropDownList StudentLectureDropDownList;
		protected System.Web.UI.WebControls.DropDownList ChooseLectureDropDownList;
		protected System.Web.UI.WebControls.Label StudentLectureLabel;
		protected System.Web.UI.WebControls.DataGrid LectureTimesDataGrid;
		protected System.Web.UI.WebControls.Button btnGrdUpdate;
		protected System.Web.UI.WebControls.Button addStudentButton;
	
		private void Page_Load(object sender, System.EventArgs e)
		{

			// init the web service class:
			lectureService = new LectureService();

			// init the drop down lists: 
			if(!IsPostBack) {
				fillDropDowns();
			}
				
			// retrieve the lecture times table:
			dataSet = lectureService.GetArrivalTimes();
			
			refreshGrid();

		}

		
		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.addStudentButton.Click += new System.EventHandler(this.addStudentButton_Click);
			this.btnGrdUpdate.Click += new System.EventHandler(this.btnGrdUpdate_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void addStudentButton_Click(object sender, System.EventArgs e)
		{
			// get the entered student attributes:
			string studentName = StudentNameTextBox.Text;
			string studentLecture = StudentLectureDropDownList.SelectedValue;
			DateTime arrivalTime = System.DateTime.Now;

			// insert a new row to the (local) dataSet:
			DataRow newRow = dataSet.Tables["ssdTable"].NewRow();
			newRow["name"] = studentName;
			newRow["lectureTopic"] = studentLecture;
			newRow["arrivalTime"] = arrivalTime;
			dataSet.Tables["ssdTable"].Rows.Add(newRow);

			// update the remote DB:
			lectureService.UpdateArrivalTimes(dataSet.GetChanges());
			
			// refresh the grid and the drop down list:
			if(!ChooseLectureDropDownList.Items.Contains(StudentLectureDropDownList.SelectedItem)) {	
				ChooseLectureDropDownList.Items.Add(studentLecture);
			}

			refreshGrid();
		}

		private void fillDropDowns()
		{
			StudentLectureDropDownList.Items.Add("J2ME");
			StudentLectureDropDownList.Items.Add("ASP.NET");
			StudentLectureDropDownList.Items.Add("AJAX");
			StudentLectureDropDownList.Items.Add("NetBeans IDE");
			StudentLectureDropDownList.Items.Add("Security: Mal-Ware");
			StudentLectureDropDownList.Items.Add(".NET Framework");
			StudentLectureDropDownList.Items.Add("DirectX");
			StudentLectureDropDownList.Items.Add("Open Source Development");
			StudentLectureDropDownList.Items.Add("Configuration Management");
			StudentLectureDropDownList.Items.Add("Automatic Testing Rational");
			StudentLectureDropDownList.Items.Add("Firewall");
			StudentLectureDropDownList.Items.Add("Code Generation Tools");
			StudentLectureDropDownList.Items.Add("Web Services");
			StudentLectureDropDownList.Items.Add("ADO.Net");

			DataSet lecturesDataSet = lectureService.GetLectureTopics();
			foreach(DataRow r in lecturesDataSet.Tables["ssdTable"].Rows) 
			{
				ChooseLectureDropDownList.Items.Add(r["lectureTopic"].ToString().Trim());
			}

		}

		private void refreshGrid() 
		{
			dataSet.Tables["ssdTable"].DefaultView.Sort = "arrivalTime";
			dataSet.Tables["ssdTable"].DefaultView.RowFilter = "lectureTopic = '" + ChooseLectureDropDownList.SelectedValue + "'";
			LectureTimesDataGrid.DataSource = dataSet.Tables["ssdTable"].DefaultView;
			LectureTimesDataGrid.DataBind();
		}

		private void btnGrdUpdate_Click(object sender, System.EventArgs e)
		{
			refreshGrid();
		}
		
	}
}
