using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Web;
using System.Web.Services;
using System.Data.SqlClient;


namespace Ado_Web_Service
{
	
	/*
	 * Class LectureService
	 * Provides web service methods for remote retrival and manipulation of 
	 * the ssd lecture arrival times database.
	 */ 
	public class LectureService : System.Web.Services.WebService
	{
		private SqlConnection ssdConn = new SqlConnection("Data Source=127.0.0.1,1433;Network Library=DBMSSOCN;Initial Catalog=AdoDemoDb;User ID=sa;Password=;");

		public LectureService()
		{
			//CODEGEN: This call is required by the ASP.NET Web Services Designer
			InitializeComponent();
		}

		#region Component Designer generated code
		
		//Required by the Web Services Designer 
		private IContainer components = null;
				
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if(disposing && components != null)
			{
				components.Dispose();
			}
			base.Dispose(disposing);		
		}
		
		#endregion

		/*
		 * Returns a dataSet containing the lecture arrival times table.
		 */
		[WebMethod( Description = "Returns students' arrival times", EnableSession = false )]
		public DataSet GetArrivalTimes()
		{
			// query the db:
			SqlDataAdapter dataAdapter = new SqlDataAdapter("SELECT * FROM ssdTable", ssdConn);

			// retrieve the rows to the dataSet: 
			DataSet dataSet = new DataSet();
			dataAdapter.Fill(dataSet, "ssdTable");

			return dataSet;
		}

		/*
		 * Returns a dataSet containing the lecture topics.
		 */
		[WebMethod( Description = "Returns the lectures' topics", EnableSession = false )]
		public DataSet GetLectureTopics()
		{
			// query the db:
			SqlDataAdapter dataAdapter = new SqlDataAdapter("select distinct lectureTopic from ssdTable", ssdConn);

			// retrieve the rows to the dataSet: 
			DataSet dataSet = new DataSet();
			dataAdapter.Fill(dataSet, "ssdTable");

			return dataSet;
		}


		/*
		 * Updates the lecture times table according to the given dataSet.
		 */
		[WebMethod( Description = "Updates students' arrival times", EnableSession = false )]
		public DataSet UpdateArrivalTimes(DataSet dataSet)
		{
			SqlDataAdapter dataAdapter = new SqlDataAdapter();

			// sql statement for inserts:
			dataAdapter.InsertCommand = new SqlCommand("INSERT INTO ssdTable (name, lectureTopic, arrivalTime) " +
				"Values(@name, @lectureTopic, @arrivalTime)", ssdConn);
			// params for the insert statement:
			dataAdapter.InsertCommand.Parameters.Add("@name", SqlDbType.Char, 30, "name");
			dataAdapter.InsertCommand.Parameters.Add("@lectureTopic", SqlDbType.Char, 30, "lectureTopic");
			dataAdapter.InsertCommand.Parameters.Add("@arrivalTime", SqlDbType.DateTime, 8, "arrivalTime");

			// sql statement for updates of values:
			dataAdapter.UpdateCommand = new SqlCommand("UPDATE Customers Set name = @name, " +
				"lectureTopic = @lectureTopic, arrivalTime = @arrivalTime WHERE name = @Oldname AND lectureTopic = @oldLectureTopic", ssdConn);
			// params for the update statement:
			dataAdapter.UpdateCommand.Parameters.Add("@name", SqlDbType.Char, 30, "name");
			dataAdapter.UpdateCommand.Parameters.Add("@lectureTopic", SqlDbType.Char, 30, "lectureTopic");
			dataAdapter.UpdateCommand.Parameters.Add("@arrivalTime", SqlDbType.DateTime, 8, "arrivalTime");
			SqlParameter myParam = dataAdapter.UpdateCommand.Parameters.Add("@Oldname", SqlDbType.Char, 30, "name");
			SqlParameter myParam2 = dataAdapter.UpdateCommand.Parameters.Add("@oldLectureTopic", SqlDbType.Char, 30, "lectureTopic");
			// indicates that myParam refrences the data before the update:
			myParam.SourceVersion = DataRowVersion.Original;
			myParam2.SourceVersion = DataRowVersion.Original;

			// sql statement and param for delete:
			dataAdapter.DeleteCommand = new SqlCommand("DELETE FROM Customers WHERE name = @name AND lectureTopic = @lectureTopic", ssdConn);
			myParam = dataAdapter.DeleteCommand.Parameters.Add("@name", SqlDbType.Char, 30, "name");
			myParam2 = dataAdapter.DeleteCommand.Parameters.Add("@lectureTopic", SqlDbType.Char, 30, "lectureTopic");

			dataAdapter.Update(dataSet, "ssdTable");

			return dataSet;
		}
		
		
	}
}
